// ==============================================================
// File generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2012.2.1
// Copyright (C) 2012 Xilinx Inc. All rights reserved.
// 
// ==============================================================

`timescale 1ns/1ps
module AXI4LiteS_if
#(parameter
    C_ADDR_WIDTH = 32,
    C_DATA_WIDTH = 32
)(
    // axi4 lite slave signals
    input  wire                      ACLK,
    input  wire                      ARESETN,
    input  wire [C_ADDR_WIDTH-1:0]   AWADDR,
    input  wire                      AWVALID,
    output wire                      AWREADY,
    input  wire [C_DATA_WIDTH-1:0]   WDATA,
    input  wire [C_DATA_WIDTH/8-1:0] WSTRB,
    input  wire                      WVALID,
    output wire                      WREADY,
    output wire [1:0]                BRESP,
    output wire                      BVALID,
    input  wire                      BREADY,
    input  wire [C_ADDR_WIDTH-1:0]   ARADDR,
    input  wire                      ARVALID,
    output wire                      ARREADY,
    output wire [C_DATA_WIDTH-1:0]   RDATA,
    output wire [1:0]                RRESP,
    output wire                      RVALID,
    input  wire                      RREADY,
    output wire                      interrupt,
    // user signals
    output wire [31:0]               I_p_srcGrid,
    output wire [31:0]               I_p_dstGrid,
    output wire [31:0]               I_nsteps,
    output wire                      I_ap_start,
    input  wire                      O_ap_done,
    input  wire                      O_ap_idle
);
//------------------------Address Info-------------------
// 0x00 : Control signals
//        bit 0  - ap_start (Read/Write/SC)
//        bit 1  - ap_done (Read/COR)
//        bit 2  - ap_idle (Read)
//        others - reserved
// 0x04 : Global Interrupt Enable Register
//        bit 0  - Global Interrupt Enable (Read/Write)
//        others - reserved
// 0x08 : IP Interrupt Enable Register (Read/Write)
//        bit 0  - Channel 0 (ap_done)
//        others - reserved
// 0x0c : IP Interrupt Status Register (Read/TOW)
//        bit 0  - Channel 0 (ap_done)
//        others - reserved
// 0x10 : reserved
// 0x14 : Data signal of p_srcGrid
//        bit 31~0 - p_srcGrid[31:0] (Read/Write)
// 0x18 : reserved
// 0x1c : Data signal of p_dstGrid
//        bit 31~0 - p_dstGrid[31:0] (Read/Write)
// 0x20 : reserved
// 0x24 : Data signal of nsteps
//        bit 31~0 - nsteps[31:0] (Read/Write)
// (SC = Self Clear, COR = Clear on Read, TOW = Toggle on Write, COH = Clear on Handshake)

//------------------------Parameter----------------------
// address bits
localparam
    ADDR_BITS = 6;

// address
localparam
    ADDR_AP_CTRL          = 6'h00,
    ADDR_GIE              = 6'h04,
    ADDR_IER              = 6'h08,
    ADDR_ISR              = 6'h0c,
    ADDR_P_SRCGRID_CTRL   = 6'h10,
    ADDR_P_SRCGRID_DATA_0 = 6'h14,
    ADDR_P_DSTGRID_CTRL   = 6'h18,
    ADDR_P_DSTGRID_DATA_0 = 6'h1c,
    ADDR_NSTEPS_CTRL      = 6'h20,
    ADDR_NSTEPS_DATA_0    = 6'h24;

// axi write fsm
localparam
    WRIDLE = 2'd0,
    WRDATA = 2'd1,
    WRRESP = 2'd2;

// axi read fsm
localparam
    RDIDLE = 2'd0,
    RDDATA = 2'd1;

//------------------------Local signal-------------------
// axi write
reg  [1:0]           wstate;
reg  [1:0]           wnext;
reg  [ADDR_BITS-1:0] waddr;
wire [31:0]          wmask;
wire                 aw_hs;
wire                 w_hs;
// axi read
reg  [1:0]           rstate;
reg  [1:0]           rnext;
reg  [31:0]          rdata;
wire                 ar_hs;
wire [ADDR_BITS-1:0] raddr;
// internal registers
wire                 ap_idle;
reg                  ap_done;
reg                  ap_start;
reg                  gie;
reg                  ier;
reg                  isr;
reg  [31:0]          _p_srcGrid;
reg  [31:0]          _p_dstGrid;
reg  [31:0]          _nsteps;

//------------------------Body---------------------------
//++++++++++++++++++++++++axi write++++++++++++++++++++++
assign AWREADY = (wstate == WRIDLE);
assign WREADY  = (wstate == WRDATA);
assign BRESP   = 2'b00;  // OKAY
assign BVALID  = (wstate == WRRESP);
assign wmask   = { {8{WSTRB[3]}}, {8{WSTRB[2]}}, {8{WSTRB[1]}}, {8{WSTRB[0]}} };
assign aw_hs   = AWVALID & AWREADY;
assign w_hs    = WVALID & WREADY;

// wstate
always @(posedge ACLK) begin
    if (~ARESETN)
        wstate <= WRIDLE;
    else
        wstate <= wnext;
end

// wnext
always @(*) begin
    case (wstate)
        WRIDLE:
            if (AWVALID)
                wnext = WRDATA;
            else
                wnext = WRIDLE;
        WRDATA:
            if (WVALID)
                wnext = WRRESP;
            else
                wnext = WRDATA;
        WRRESP:
            if (BREADY)
                wnext = WRIDLE;
            else
                wnext = WRRESP;
        default:
            wnext = WRIDLE;
    endcase
end

// waddr
always @(posedge ACLK) begin
    if (aw_hs)
        waddr <= AWADDR[ADDR_BITS-1:0];
end
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++

//++++++++++++++++++++++++axi read+++++++++++++++++++++++
assign ARREADY = (rstate == RDIDLE);
assign RDATA   = rdata;
assign RRESP   = 2'b00;  // OKAY
assign RVALID  = (rstate == RDDATA);
assign ar_hs   = ARVALID & ARREADY;
assign raddr   = ARADDR[ADDR_BITS-1:0];

// rstate
always @(posedge ACLK) begin
    if (~ARESETN)
        rstate <= RDIDLE;
    else
        rstate <= rnext;
end

// rnext
always @(*) begin
    case (rstate)
        RDIDLE:
            if (ARVALID)
                rnext = RDDATA;
            else
                rnext = RDIDLE;
        RDDATA:
            if (RREADY)
                rnext = RDIDLE;
            else
                rnext = RDDATA;
        default:
            rnext = RDIDLE;
    endcase
end

// rdata
always @(posedge ACLK) begin
    if (ar_hs) begin
        rdata <= 1'b0;
        case (raddr)
            ADDR_AP_CTRL: begin
                rdata[0] <= ap_start;
                rdata[1] <= ap_done;
                rdata[2] <= ap_idle;
            end
            ADDR_GIE: begin
                rdata <= gie;
            end
            ADDR_IER: begin
                rdata <= ier;
            end
            ADDR_ISR: begin
                rdata <= isr;
            end
            ADDR_P_SRCGRID_DATA_0: begin
                rdata <= _p_srcGrid[31:0];
            end
            ADDR_P_DSTGRID_DATA_0: begin
                rdata <= _p_dstGrid[31:0];
            end
            ADDR_NSTEPS_DATA_0: begin
                rdata <= _nsteps[31:0];
            end
        endcase
    end
end
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++

//++++++++++++++++++++++++internal registers+++++++++++++
assign interrupt   = gie & (|isr);
assign I_ap_start  = ap_start;
assign ap_idle     = O_ap_idle;
assign I_p_srcGrid = _p_srcGrid;
assign I_p_dstGrid = _p_dstGrid;
assign I_nsteps    = _nsteps;

// ap_start
always @(posedge ACLK) begin
    if (~ARESETN)
        ap_start <= 1'b0;
    else if (w_hs && waddr == ADDR_AP_CTRL && WSTRB[0])
        ap_start <= WDATA[0];
    else
        ap_start <= 1'b0; // self clear
end

// ap_done
always @(posedge ACLK) begin
    if (~ARESETN)
        ap_done <= 1'b0;
    else if (O_ap_done)
        ap_done <= 1'b1;
    else if (ar_hs && raddr == ADDR_AP_CTRL)
        ap_done <= 1'b0; // clear on read
end

// gie
always @(posedge ACLK) begin
    if (~ARESETN)
        gie <= 1'b0;
    else if (w_hs && waddr == ADDR_GIE && WSTRB[0])
        gie <= WDATA[0];
end

// ier
always @(posedge ACLK) begin
    if (~ARESETN)
        ier <= 1'b0;
    else if (w_hs && waddr == ADDR_IER && WSTRB[0])
        ier <= WDATA[0];
end

// isr
always @(posedge ACLK) begin
    if (~ARESETN)
        isr <= 1'b0;
    else if (ier & O_ap_done)
        isr <= 1'b1;
    else if (w_hs && waddr == ADDR_ISR && WSTRB[0])
        isr <= isr ^ WDATA[0]; // toggle on write
end

// _p_srcGrid[31:0]
always @(posedge ACLK) begin
    if (w_hs && waddr == ADDR_P_SRCGRID_DATA_0)
        _p_srcGrid[31:0] <= (WDATA[31:0] & wmask) | (_p_srcGrid[31:0] & ~wmask);
end

// _p_dstGrid[31:0]
always @(posedge ACLK) begin
    if (w_hs && waddr == ADDR_P_DSTGRID_DATA_0)
        _p_dstGrid[31:0] <= (WDATA[31:0] & wmask) | (_p_dstGrid[31:0] & ~wmask);
end

// _nsteps[31:0]
always @(posedge ACLK) begin
    if (w_hs && waddr == ADDR_NSTEPS_DATA_0)
        _nsteps[31:0] <= (WDATA[31:0] & wmask) | (_nsteps[31:0] & ~wmask);
end

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++

endmodule
