//-----------------------------------------------------------------------------
// bram_block_high_elaborate.v
//-----------------------------------------------------------------------------

(* keep_hierarchy = "yes" *)
module bram_block_high_elaborate
  (
    BRAM_Rst_A,
    BRAM_Clk_A,
    BRAM_EN_A,
    BRAM_WEN_A,
    BRAM_Addr_A,
    BRAM_Din_A,
    BRAM_Dout_A,
    BRAM_Rst_B,
    BRAM_Clk_B,
    BRAM_EN_B,
    BRAM_WEN_B,
    BRAM_Addr_B,
    BRAM_Din_B,
    BRAM_Dout_B
  );
  parameter
    C_MEMSIZE = 'h10000,
    C_PORT_DWIDTH = 32,
    C_PORT_AWIDTH = 32,
    C_NUM_WE = 4,
    C_FAMILY = "zynq";
  input BRAM_Rst_A;
  input BRAM_Clk_A;
  input BRAM_EN_A;
  input [0:C_NUM_WE-1] BRAM_WEN_A;
  input [0:C_PORT_AWIDTH-1] BRAM_Addr_A;
  output [0:C_PORT_DWIDTH-1] BRAM_Din_A;
  input [0:C_PORT_DWIDTH-1] BRAM_Dout_A;
  input BRAM_Rst_B;
  input BRAM_Clk_B;
  input BRAM_EN_B;
  input [0:C_NUM_WE-1] BRAM_WEN_B;
  input [0:C_PORT_AWIDTH-1] BRAM_Addr_B;
  output [0:C_PORT_DWIDTH-1] BRAM_Din_B;
  input [0:C_PORT_DWIDTH-1] BRAM_Dout_B;

  // Internal signals

  wire net_gnd0;
  wire [3:0] net_gnd4;
  wire [0:0] pgassign1;
  wire [0:0] pgassign2;
  wire [0:29] pgassign3;
  wire [0:3] pgassign4;
  wire [15:0] pgassign5;
  wire [31:0] pgassign6;
  wire [31:0] pgassign7;
  wire [3:0] pgassign8;
  wire [15:0] pgassign9;
  wire [31:0] pgassign10;
  wire [31:0] pgassign11;
  wire [7:0] pgassign12;
  wire [15:0] pgassign13;
  wire [31:0] pgassign14;
  wire [31:0] pgassign15;
  wire [3:0] pgassign16;
  wire [15:0] pgassign17;
  wire [31:0] pgassign18;
  wire [31:0] pgassign19;
  wire [7:0] pgassign20;
  wire [15:0] pgassign21;
  wire [31:0] pgassign22;
  wire [31:0] pgassign23;
  wire [3:0] pgassign24;
  wire [15:0] pgassign25;
  wire [31:0] pgassign26;
  wire [31:0] pgassign27;
  wire [7:0] pgassign28;
  wire [15:0] pgassign29;
  wire [31:0] pgassign30;
  wire [31:0] pgassign31;
  wire [3:0] pgassign32;
  wire [15:0] pgassign33;
  wire [31:0] pgassign34;
  wire [31:0] pgassign35;
  wire [7:0] pgassign36;
  wire [15:0] pgassign37;
  wire [31:0] pgassign38;
  wire [31:0] pgassign39;
  wire [3:0] pgassign40;
  wire [15:0] pgassign41;
  wire [31:0] pgassign42;
  wire [31:0] pgassign43;
  wire [7:0] pgassign44;
  wire [15:0] pgassign45;
  wire [31:0] pgassign46;
  wire [31:0] pgassign47;
  wire [3:0] pgassign48;
  wire [15:0] pgassign49;
  wire [31:0] pgassign50;
  wire [31:0] pgassign51;
  wire [7:0] pgassign52;
  wire [15:0] pgassign53;
  wire [31:0] pgassign54;
  wire [31:0] pgassign55;
  wire [3:0] pgassign56;
  wire [15:0] pgassign57;
  wire [31:0] pgassign58;
  wire [31:0] pgassign59;
  wire [7:0] pgassign60;
  wire [15:0] pgassign61;
  wire [31:0] pgassign62;
  wire [31:0] pgassign63;
  wire [3:0] pgassign64;
  wire [15:0] pgassign65;
  wire [31:0] pgassign66;
  wire [31:0] pgassign67;
  wire [7:0] pgassign68;
  wire [15:0] pgassign69;
  wire [31:0] pgassign70;
  wire [31:0] pgassign71;
  wire [3:0] pgassign72;
  wire [15:0] pgassign73;
  wire [31:0] pgassign74;
  wire [31:0] pgassign75;
  wire [7:0] pgassign76;
  wire [15:0] pgassign77;
  wire [31:0] pgassign78;
  wire [31:0] pgassign79;
  wire [3:0] pgassign80;
  wire [15:0] pgassign81;
  wire [31:0] pgassign82;
  wire [31:0] pgassign83;
  wire [7:0] pgassign84;
  wire [15:0] pgassign85;
  wire [31:0] pgassign86;
  wire [31:0] pgassign87;
  wire [3:0] pgassign88;
  wire [15:0] pgassign89;
  wire [31:0] pgassign90;
  wire [31:0] pgassign91;
  wire [7:0] pgassign92;
  wire [15:0] pgassign93;
  wire [31:0] pgassign94;
  wire [31:0] pgassign95;
  wire [3:0] pgassign96;
  wire [15:0] pgassign97;
  wire [31:0] pgassign98;
  wire [31:0] pgassign99;
  wire [7:0] pgassign100;
  wire [15:0] pgassign101;
  wire [31:0] pgassign102;
  wire [31:0] pgassign103;
  wire [3:0] pgassign104;
  wire [15:0] pgassign105;
  wire [31:0] pgassign106;
  wire [31:0] pgassign107;
  wire [7:0] pgassign108;
  wire [15:0] pgassign109;
  wire [31:0] pgassign110;
  wire [31:0] pgassign111;
  wire [3:0] pgassign112;
  wire [15:0] pgassign113;
  wire [31:0] pgassign114;
  wire [31:0] pgassign115;
  wire [7:0] pgassign116;
  wire [15:0] pgassign117;
  wire [31:0] pgassign118;
  wire [31:0] pgassign119;
  wire [3:0] pgassign120;
  wire [15:0] pgassign121;
  wire [31:0] pgassign122;
  wire [31:0] pgassign123;
  wire [7:0] pgassign124;
  wire [15:0] pgassign125;
  wire [31:0] pgassign126;
  wire [31:0] pgassign127;
  wire [3:0] pgassign128;
  wire [15:0] pgassign129;
  wire [31:0] pgassign130;
  wire [31:0] pgassign131;
  wire [7:0] pgassign132;

  // Internal assignments

  assign pgassign1[0:0] = 1'b1;
  assign pgassign2[0:0] = 1'b0;
  assign pgassign3[0:29] = 30'b000000000000000000000000000000;
  assign pgassign4[0:3] = 4'b0000;
  assign pgassign5[15:15] = 1'b1;
  assign pgassign5[14:1] = BRAM_Addr_A[16:29];
  assign pgassign5[0:0] = 1'b0;
  assign pgassign6[31:2] = 30'b000000000000000000000000000000;
  assign pgassign6[1:0] = BRAM_Dout_A[0:1];
  assign BRAM_Din_A[0:1] = pgassign7[1:0];
  assign pgassign8[3:3] = BRAM_WEN_A[0:0];
  assign pgassign8[2:2] = BRAM_WEN_A[0:0];
  assign pgassign8[1:1] = BRAM_WEN_A[0:0];
  assign pgassign8[0:0] = BRAM_WEN_A[0:0];
  assign pgassign9[15:15] = 1'b1;
  assign pgassign9[14:1] = BRAM_Addr_B[16:29];
  assign pgassign9[0:0] = 1'b0;
  assign pgassign10[31:2] = 30'b000000000000000000000000000000;
  assign pgassign10[1:0] = BRAM_Dout_B[0:1];
  assign BRAM_Din_B[0:1] = pgassign11[1:0];
  assign pgassign12[7:4] = 4'b0000;
  assign pgassign12[3:3] = BRAM_WEN_B[0:0];
  assign pgassign12[2:2] = BRAM_WEN_B[0:0];
  assign pgassign12[1:1] = BRAM_WEN_B[0:0];
  assign pgassign12[0:0] = BRAM_WEN_B[0:0];
  assign pgassign13[15:15] = 1'b1;
  assign pgassign13[14:1] = BRAM_Addr_A[16:29];
  assign pgassign13[0:0] = 1'b0;
  assign pgassign14[31:2] = 30'b000000000000000000000000000000;
  assign pgassign14[1:0] = BRAM_Dout_A[2:3];
  assign BRAM_Din_A[2:3] = pgassign15[1:0];
  assign pgassign16[3:3] = BRAM_WEN_A[0:0];
  assign pgassign16[2:2] = BRAM_WEN_A[0:0];
  assign pgassign16[1:1] = BRAM_WEN_A[0:0];
  assign pgassign16[0:0] = BRAM_WEN_A[0:0];
  assign pgassign17[15:15] = 1'b1;
  assign pgassign17[14:1] = BRAM_Addr_B[16:29];
  assign pgassign17[0:0] = 1'b0;
  assign pgassign18[31:2] = 30'b000000000000000000000000000000;
  assign pgassign18[1:0] = BRAM_Dout_B[2:3];
  assign BRAM_Din_B[2:3] = pgassign19[1:0];
  assign pgassign20[7:4] = 4'b0000;
  assign pgassign20[3:3] = BRAM_WEN_B[0:0];
  assign pgassign20[2:2] = BRAM_WEN_B[0:0];
  assign pgassign20[1:1] = BRAM_WEN_B[0:0];
  assign pgassign20[0:0] = BRAM_WEN_B[0:0];
  assign pgassign21[15:15] = 1'b1;
  assign pgassign21[14:1] = BRAM_Addr_A[16:29];
  assign pgassign21[0:0] = 1'b0;
  assign pgassign22[31:2] = 30'b000000000000000000000000000000;
  assign pgassign22[1:0] = BRAM_Dout_A[4:5];
  assign BRAM_Din_A[4:5] = pgassign23[1:0];
  assign pgassign24[3:3] = BRAM_WEN_A[0:0];
  assign pgassign24[2:2] = BRAM_WEN_A[0:0];
  assign pgassign24[1:1] = BRAM_WEN_A[0:0];
  assign pgassign24[0:0] = BRAM_WEN_A[0:0];
  assign pgassign25[15:15] = 1'b1;
  assign pgassign25[14:1] = BRAM_Addr_B[16:29];
  assign pgassign25[0:0] = 1'b0;
  assign pgassign26[31:2] = 30'b000000000000000000000000000000;
  assign pgassign26[1:0] = BRAM_Dout_B[4:5];
  assign BRAM_Din_B[4:5] = pgassign27[1:0];
  assign pgassign28[7:4] = 4'b0000;
  assign pgassign28[3:3] = BRAM_WEN_B[0:0];
  assign pgassign28[2:2] = BRAM_WEN_B[0:0];
  assign pgassign28[1:1] = BRAM_WEN_B[0:0];
  assign pgassign28[0:0] = BRAM_WEN_B[0:0];
  assign pgassign29[15:15] = 1'b1;
  assign pgassign29[14:1] = BRAM_Addr_A[16:29];
  assign pgassign29[0:0] = 1'b0;
  assign pgassign30[31:2] = 30'b000000000000000000000000000000;
  assign pgassign30[1:0] = BRAM_Dout_A[6:7];
  assign BRAM_Din_A[6:7] = pgassign31[1:0];
  assign pgassign32[3:3] = BRAM_WEN_A[0:0];
  assign pgassign32[2:2] = BRAM_WEN_A[0:0];
  assign pgassign32[1:1] = BRAM_WEN_A[0:0];
  assign pgassign32[0:0] = BRAM_WEN_A[0:0];
  assign pgassign33[15:15] = 1'b1;
  assign pgassign33[14:1] = BRAM_Addr_B[16:29];
  assign pgassign33[0:0] = 1'b0;
  assign pgassign34[31:2] = 30'b000000000000000000000000000000;
  assign pgassign34[1:0] = BRAM_Dout_B[6:7];
  assign BRAM_Din_B[6:7] = pgassign35[1:0];
  assign pgassign36[7:4] = 4'b0000;
  assign pgassign36[3:3] = BRAM_WEN_B[0:0];
  assign pgassign36[2:2] = BRAM_WEN_B[0:0];
  assign pgassign36[1:1] = BRAM_WEN_B[0:0];
  assign pgassign36[0:0] = BRAM_WEN_B[0:0];
  assign pgassign37[15:15] = 1'b1;
  assign pgassign37[14:1] = BRAM_Addr_A[16:29];
  assign pgassign37[0:0] = 1'b0;
  assign pgassign38[31:2] = 30'b000000000000000000000000000000;
  assign pgassign38[1:0] = BRAM_Dout_A[8:9];
  assign BRAM_Din_A[8:9] = pgassign39[1:0];
  assign pgassign40[3:3] = BRAM_WEN_A[1:1];
  assign pgassign40[2:2] = BRAM_WEN_A[1:1];
  assign pgassign40[1:1] = BRAM_WEN_A[1:1];
  assign pgassign40[0:0] = BRAM_WEN_A[1:1];
  assign pgassign41[15:15] = 1'b1;
  assign pgassign41[14:1] = BRAM_Addr_B[16:29];
  assign pgassign41[0:0] = 1'b0;
  assign pgassign42[31:2] = 30'b000000000000000000000000000000;
  assign pgassign42[1:0] = BRAM_Dout_B[8:9];
  assign BRAM_Din_B[8:9] = pgassign43[1:0];
  assign pgassign44[7:4] = 4'b0000;
  assign pgassign44[3:3] = BRAM_WEN_B[1:1];
  assign pgassign44[2:2] = BRAM_WEN_B[1:1];
  assign pgassign44[1:1] = BRAM_WEN_B[1:1];
  assign pgassign44[0:0] = BRAM_WEN_B[1:1];
  assign pgassign45[15:15] = 1'b1;
  assign pgassign45[14:1] = BRAM_Addr_A[16:29];
  assign pgassign45[0:0] = 1'b0;
  assign pgassign46[31:2] = 30'b000000000000000000000000000000;
  assign pgassign46[1:0] = BRAM_Dout_A[10:11];
  assign BRAM_Din_A[10:11] = pgassign47[1:0];
  assign pgassign48[3:3] = BRAM_WEN_A[1:1];
  assign pgassign48[2:2] = BRAM_WEN_A[1:1];
  assign pgassign48[1:1] = BRAM_WEN_A[1:1];
  assign pgassign48[0:0] = BRAM_WEN_A[1:1];
  assign pgassign49[15:15] = 1'b1;
  assign pgassign49[14:1] = BRAM_Addr_B[16:29];
  assign pgassign49[0:0] = 1'b0;
  assign pgassign50[31:2] = 30'b000000000000000000000000000000;
  assign pgassign50[1:0] = BRAM_Dout_B[10:11];
  assign BRAM_Din_B[10:11] = pgassign51[1:0];
  assign pgassign52[7:4] = 4'b0000;
  assign pgassign52[3:3] = BRAM_WEN_B[1:1];
  assign pgassign52[2:2] = BRAM_WEN_B[1:1];
  assign pgassign52[1:1] = BRAM_WEN_B[1:1];
  assign pgassign52[0:0] = BRAM_WEN_B[1:1];
  assign pgassign53[15:15] = 1'b1;
  assign pgassign53[14:1] = BRAM_Addr_A[16:29];
  assign pgassign53[0:0] = 1'b0;
  assign pgassign54[31:2] = 30'b000000000000000000000000000000;
  assign pgassign54[1:0] = BRAM_Dout_A[12:13];
  assign BRAM_Din_A[12:13] = pgassign55[1:0];
  assign pgassign56[3:3] = BRAM_WEN_A[1:1];
  assign pgassign56[2:2] = BRAM_WEN_A[1:1];
  assign pgassign56[1:1] = BRAM_WEN_A[1:1];
  assign pgassign56[0:0] = BRAM_WEN_A[1:1];
  assign pgassign57[15:15] = 1'b1;
  assign pgassign57[14:1] = BRAM_Addr_B[16:29];
  assign pgassign57[0:0] = 1'b0;
  assign pgassign58[31:2] = 30'b000000000000000000000000000000;
  assign pgassign58[1:0] = BRAM_Dout_B[12:13];
  assign BRAM_Din_B[12:13] = pgassign59[1:0];
  assign pgassign60[7:4] = 4'b0000;
  assign pgassign60[3:3] = BRAM_WEN_B[1:1];
  assign pgassign60[2:2] = BRAM_WEN_B[1:1];
  assign pgassign60[1:1] = BRAM_WEN_B[1:1];
  assign pgassign60[0:0] = BRAM_WEN_B[1:1];
  assign pgassign61[15:15] = 1'b1;
  assign pgassign61[14:1] = BRAM_Addr_A[16:29];
  assign pgassign61[0:0] = 1'b0;
  assign pgassign62[31:2] = 30'b000000000000000000000000000000;
  assign pgassign62[1:0] = BRAM_Dout_A[14:15];
  assign BRAM_Din_A[14:15] = pgassign63[1:0];
  assign pgassign64[3:3] = BRAM_WEN_A[1:1];
  assign pgassign64[2:2] = BRAM_WEN_A[1:1];
  assign pgassign64[1:1] = BRAM_WEN_A[1:1];
  assign pgassign64[0:0] = BRAM_WEN_A[1:1];
  assign pgassign65[15:15] = 1'b1;
  assign pgassign65[14:1] = BRAM_Addr_B[16:29];
  assign pgassign65[0:0] = 1'b0;
  assign pgassign66[31:2] = 30'b000000000000000000000000000000;
  assign pgassign66[1:0] = BRAM_Dout_B[14:15];
  assign BRAM_Din_B[14:15] = pgassign67[1:0];
  assign pgassign68[7:4] = 4'b0000;
  assign pgassign68[3:3] = BRAM_WEN_B[1:1];
  assign pgassign68[2:2] = BRAM_WEN_B[1:1];
  assign pgassign68[1:1] = BRAM_WEN_B[1:1];
  assign pgassign68[0:0] = BRAM_WEN_B[1:1];
  assign pgassign69[15:15] = 1'b1;
  assign pgassign69[14:1] = BRAM_Addr_A[16:29];
  assign pgassign69[0:0] = 1'b0;
  assign pgassign70[31:2] = 30'b000000000000000000000000000000;
  assign pgassign70[1:0] = BRAM_Dout_A[16:17];
  assign BRAM_Din_A[16:17] = pgassign71[1:0];
  assign pgassign72[3:3] = BRAM_WEN_A[2:2];
  assign pgassign72[2:2] = BRAM_WEN_A[2:2];
  assign pgassign72[1:1] = BRAM_WEN_A[2:2];
  assign pgassign72[0:0] = BRAM_WEN_A[2:2];
  assign pgassign73[15:15] = 1'b1;
  assign pgassign73[14:1] = BRAM_Addr_B[16:29];
  assign pgassign73[0:0] = 1'b0;
  assign pgassign74[31:2] = 30'b000000000000000000000000000000;
  assign pgassign74[1:0] = BRAM_Dout_B[16:17];
  assign BRAM_Din_B[16:17] = pgassign75[1:0];
  assign pgassign76[7:4] = 4'b0000;
  assign pgassign76[3:3] = BRAM_WEN_B[2:2];
  assign pgassign76[2:2] = BRAM_WEN_B[2:2];
  assign pgassign76[1:1] = BRAM_WEN_B[2:2];
  assign pgassign76[0:0] = BRAM_WEN_B[2:2];
  assign pgassign77[15:15] = 1'b1;
  assign pgassign77[14:1] = BRAM_Addr_A[16:29];
  assign pgassign77[0:0] = 1'b0;
  assign pgassign78[31:2] = 30'b000000000000000000000000000000;
  assign pgassign78[1:0] = BRAM_Dout_A[18:19];
  assign BRAM_Din_A[18:19] = pgassign79[1:0];
  assign pgassign80[3:3] = BRAM_WEN_A[2:2];
  assign pgassign80[2:2] = BRAM_WEN_A[2:2];
  assign pgassign80[1:1] = BRAM_WEN_A[2:2];
  assign pgassign80[0:0] = BRAM_WEN_A[2:2];
  assign pgassign81[15:15] = 1'b1;
  assign pgassign81[14:1] = BRAM_Addr_B[16:29];
  assign pgassign81[0:0] = 1'b0;
  assign pgassign82[31:2] = 30'b000000000000000000000000000000;
  assign pgassign82[1:0] = BRAM_Dout_B[18:19];
  assign BRAM_Din_B[18:19] = pgassign83[1:0];
  assign pgassign84[7:4] = 4'b0000;
  assign pgassign84[3:3] = BRAM_WEN_B[2:2];
  assign pgassign84[2:2] = BRAM_WEN_B[2:2];
  assign pgassign84[1:1] = BRAM_WEN_B[2:2];
  assign pgassign84[0:0] = BRAM_WEN_B[2:2];
  assign pgassign85[15:15] = 1'b1;
  assign pgassign85[14:1] = BRAM_Addr_A[16:29];
  assign pgassign85[0:0] = 1'b0;
  assign pgassign86[31:2] = 30'b000000000000000000000000000000;
  assign pgassign86[1:0] = BRAM_Dout_A[20:21];
  assign BRAM_Din_A[20:21] = pgassign87[1:0];
  assign pgassign88[3:3] = BRAM_WEN_A[2:2];
  assign pgassign88[2:2] = BRAM_WEN_A[2:2];
  assign pgassign88[1:1] = BRAM_WEN_A[2:2];
  assign pgassign88[0:0] = BRAM_WEN_A[2:2];
  assign pgassign89[15:15] = 1'b1;
  assign pgassign89[14:1] = BRAM_Addr_B[16:29];
  assign pgassign89[0:0] = 1'b0;
  assign pgassign90[31:2] = 30'b000000000000000000000000000000;
  assign pgassign90[1:0] = BRAM_Dout_B[20:21];
  assign BRAM_Din_B[20:21] = pgassign91[1:0];
  assign pgassign92[7:4] = 4'b0000;
  assign pgassign92[3:3] = BRAM_WEN_B[2:2];
  assign pgassign92[2:2] = BRAM_WEN_B[2:2];
  assign pgassign92[1:1] = BRAM_WEN_B[2:2];
  assign pgassign92[0:0] = BRAM_WEN_B[2:2];
  assign pgassign93[15:15] = 1'b1;
  assign pgassign93[14:1] = BRAM_Addr_A[16:29];
  assign pgassign93[0:0] = 1'b0;
  assign pgassign94[31:2] = 30'b000000000000000000000000000000;
  assign pgassign94[1:0] = BRAM_Dout_A[22:23];
  assign BRAM_Din_A[22:23] = pgassign95[1:0];
  assign pgassign96[3:3] = BRAM_WEN_A[2:2];
  assign pgassign96[2:2] = BRAM_WEN_A[2:2];
  assign pgassign96[1:1] = BRAM_WEN_A[2:2];
  assign pgassign96[0:0] = BRAM_WEN_A[2:2];
  assign pgassign97[15:15] = 1'b1;
  assign pgassign97[14:1] = BRAM_Addr_B[16:29];
  assign pgassign97[0:0] = 1'b0;
  assign pgassign98[31:2] = 30'b000000000000000000000000000000;
  assign pgassign98[1:0] = BRAM_Dout_B[22:23];
  assign BRAM_Din_B[22:23] = pgassign99[1:0];
  assign pgassign100[7:4] = 4'b0000;
  assign pgassign100[3:3] = BRAM_WEN_B[2:2];
  assign pgassign100[2:2] = BRAM_WEN_B[2:2];
  assign pgassign100[1:1] = BRAM_WEN_B[2:2];
  assign pgassign100[0:0] = BRAM_WEN_B[2:2];
  assign pgassign101[15:15] = 1'b1;
  assign pgassign101[14:1] = BRAM_Addr_A[16:29];
  assign pgassign101[0:0] = 1'b0;
  assign pgassign102[31:2] = 30'b000000000000000000000000000000;
  assign pgassign102[1:0] = BRAM_Dout_A[24:25];
  assign BRAM_Din_A[24:25] = pgassign103[1:0];
  assign pgassign104[3:3] = BRAM_WEN_A[3:3];
  assign pgassign104[2:2] = BRAM_WEN_A[3:3];
  assign pgassign104[1:1] = BRAM_WEN_A[3:3];
  assign pgassign104[0:0] = BRAM_WEN_A[3:3];
  assign pgassign105[15:15] = 1'b1;
  assign pgassign105[14:1] = BRAM_Addr_B[16:29];
  assign pgassign105[0:0] = 1'b0;
  assign pgassign106[31:2] = 30'b000000000000000000000000000000;
  assign pgassign106[1:0] = BRAM_Dout_B[24:25];
  assign BRAM_Din_B[24:25] = pgassign107[1:0];
  assign pgassign108[7:4] = 4'b0000;
  assign pgassign108[3:3] = BRAM_WEN_B[3:3];
  assign pgassign108[2:2] = BRAM_WEN_B[3:3];
  assign pgassign108[1:1] = BRAM_WEN_B[3:3];
  assign pgassign108[0:0] = BRAM_WEN_B[3:3];
  assign pgassign109[15:15] = 1'b1;
  assign pgassign109[14:1] = BRAM_Addr_A[16:29];
  assign pgassign109[0:0] = 1'b0;
  assign pgassign110[31:2] = 30'b000000000000000000000000000000;
  assign pgassign110[1:0] = BRAM_Dout_A[26:27];
  assign BRAM_Din_A[26:27] = pgassign111[1:0];
  assign pgassign112[3:3] = BRAM_WEN_A[3:3];
  assign pgassign112[2:2] = BRAM_WEN_A[3:3];
  assign pgassign112[1:1] = BRAM_WEN_A[3:3];
  assign pgassign112[0:0] = BRAM_WEN_A[3:3];
  assign pgassign113[15:15] = 1'b1;
  assign pgassign113[14:1] = BRAM_Addr_B[16:29];
  assign pgassign113[0:0] = 1'b0;
  assign pgassign114[31:2] = 30'b000000000000000000000000000000;
  assign pgassign114[1:0] = BRAM_Dout_B[26:27];
  assign BRAM_Din_B[26:27] = pgassign115[1:0];
  assign pgassign116[7:4] = 4'b0000;
  assign pgassign116[3:3] = BRAM_WEN_B[3:3];
  assign pgassign116[2:2] = BRAM_WEN_B[3:3];
  assign pgassign116[1:1] = BRAM_WEN_B[3:3];
  assign pgassign116[0:0] = BRAM_WEN_B[3:3];
  assign pgassign117[15:15] = 1'b1;
  assign pgassign117[14:1] = BRAM_Addr_A[16:29];
  assign pgassign117[0:0] = 1'b0;
  assign pgassign118[31:2] = 30'b000000000000000000000000000000;
  assign pgassign118[1:0] = BRAM_Dout_A[28:29];
  assign BRAM_Din_A[28:29] = pgassign119[1:0];
  assign pgassign120[3:3] = BRAM_WEN_A[3:3];
  assign pgassign120[2:2] = BRAM_WEN_A[3:3];
  assign pgassign120[1:1] = BRAM_WEN_A[3:3];
  assign pgassign120[0:0] = BRAM_WEN_A[3:3];
  assign pgassign121[15:15] = 1'b1;
  assign pgassign121[14:1] = BRAM_Addr_B[16:29];
  assign pgassign121[0:0] = 1'b0;
  assign pgassign122[31:2] = 30'b000000000000000000000000000000;
  assign pgassign122[1:0] = BRAM_Dout_B[28:29];
  assign BRAM_Din_B[28:29] = pgassign123[1:0];
  assign pgassign124[7:4] = 4'b0000;
  assign pgassign124[3:3] = BRAM_WEN_B[3:3];
  assign pgassign124[2:2] = BRAM_WEN_B[3:3];
  assign pgassign124[1:1] = BRAM_WEN_B[3:3];
  assign pgassign124[0:0] = BRAM_WEN_B[3:3];
  assign pgassign125[15:15] = 1'b1;
  assign pgassign125[14:1] = BRAM_Addr_A[16:29];
  assign pgassign125[0:0] = 1'b0;
  assign pgassign126[31:2] = 30'b000000000000000000000000000000;
  assign pgassign126[1:0] = BRAM_Dout_A[30:31];
  assign BRAM_Din_A[30:31] = pgassign127[1:0];
  assign pgassign128[3:3] = BRAM_WEN_A[3:3];
  assign pgassign128[2:2] = BRAM_WEN_A[3:3];
  assign pgassign128[1:1] = BRAM_WEN_A[3:3];
  assign pgassign128[0:0] = BRAM_WEN_A[3:3];
  assign pgassign129[15:15] = 1'b1;
  assign pgassign129[14:1] = BRAM_Addr_B[16:29];
  assign pgassign129[0:0] = 1'b0;
  assign pgassign130[31:2] = 30'b000000000000000000000000000000;
  assign pgassign130[1:0] = BRAM_Dout_B[30:31];
  assign BRAM_Din_B[30:31] = pgassign131[1:0];
  assign pgassign132[7:4] = 4'b0000;
  assign pgassign132[3:3] = BRAM_WEN_B[3:3];
  assign pgassign132[2:2] = BRAM_WEN_B[3:3];
  assign pgassign132[1:1] = BRAM_WEN_B[3:3];
  assign pgassign132[0:0] = BRAM_WEN_B[3:3];
  assign net_gnd0 = 1'b0;
  assign net_gnd4[3:0] = 4'b0000;

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_0.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_0 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign5 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign6 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign7 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign8 ),
      .ADDRBWRADDR ( pgassign9 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign10 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign11 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign12 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_1.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_1 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign13 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign14 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign15 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign16 ),
      .ADDRBWRADDR ( pgassign17 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign18 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign19 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign20 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_2.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_2 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign21 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign22 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign23 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign24 ),
      .ADDRBWRADDR ( pgassign25 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign26 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign27 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign28 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_3.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_3 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign29 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign30 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign31 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign32 ),
      .ADDRBWRADDR ( pgassign33 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign34 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign35 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign36 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_4.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_4 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign37 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign38 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign39 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign40 ),
      .ADDRBWRADDR ( pgassign41 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign42 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign43 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign44 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_5.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_5 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign45 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign46 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign47 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign48 ),
      .ADDRBWRADDR ( pgassign49 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign50 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign51 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign52 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_6.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_6 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign53 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign54 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign55 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign56 ),
      .ADDRBWRADDR ( pgassign57 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign58 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign59 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign60 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_7.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_7 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign61 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign62 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign63 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign64 ),
      .ADDRBWRADDR ( pgassign65 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign66 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign67 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign68 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_8.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_8 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign69 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign70 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign71 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign72 ),
      .ADDRBWRADDR ( pgassign73 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign74 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign75 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign76 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_9.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_9 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign77 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign78 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign79 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign80 ),
      .ADDRBWRADDR ( pgassign81 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign82 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign83 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign84 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_10.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_10 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign85 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign86 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign87 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign88 ),
      .ADDRBWRADDR ( pgassign89 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign90 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign91 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign92 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_11.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_11 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign93 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign94 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign95 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign96 ),
      .ADDRBWRADDR ( pgassign97 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign98 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign99 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign100 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_12.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_12 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign101 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign102 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign103 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign104 ),
      .ADDRBWRADDR ( pgassign105 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign106 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign107 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign108 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_13.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_13 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign109 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign110 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign111 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign112 ),
      .ADDRBWRADDR ( pgassign113 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign114 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign115 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign116 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_14.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_14 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign117 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign118 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign119 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign120 ),
      .ADDRBWRADDR ( pgassign121 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign122 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign123 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign124 )
    );

  (* BMM_INFO = " " *)

  RAMB36E1
    #(
      .WRITE_MODE_A ( "WRITE_FIRST" ),
      .WRITE_MODE_B ( "WRITE_FIRST" ),
      .INIT_FILE ( "bram_block_high_combined_15.mem" ),
      .READ_WIDTH_A ( 2 ),
      .READ_WIDTH_B ( 2 ),
      .WRITE_WIDTH_A ( 2 ),
      .WRITE_WIDTH_B ( 2 ),
      .RAM_EXTENSION_A ( "NONE" ),
      .RAM_EXTENSION_B ( "NONE" )
    )
    ramb36e1_15 (
      .DBITERR (  ),
      .ECCPARITY (  ),
      .INJECTDBITERR ( net_gnd0 ),
      .INJECTSBITERR ( net_gnd0 ),
      .RDADDRECC (  ),
      .SBITERR (  ),
      .ADDRARDADDR ( pgassign125 ),
      .CASCADEINA ( net_gnd0 ),
      .CASCADEOUTA (  ),
      .CLKARDCLK ( BRAM_Clk_A ),
      .DIADI ( pgassign126 ),
      .DIPADIP ( net_gnd4 ),
      .DOADO ( pgassign127 ),
      .DOPADOP (  ),
      .ENARDEN ( BRAM_EN_A ),
      .REGCEAREGCE ( net_gnd0 ),
      .RSTRAMARSTRAM ( BRAM_Rst_A ),
      .RSTREGARSTREG ( net_gnd0 ),
      .WEA ( pgassign128 ),
      .ADDRBWRADDR ( pgassign129 ),
      .CASCADEINB ( net_gnd0 ),
      .CASCADEOUTB (  ),
      .CLKBWRCLK ( BRAM_Clk_B ),
      .DIBDI ( pgassign130 ),
      .DIPBDIP ( net_gnd4 ),
      .DOBDO ( pgassign131 ),
      .DOPBDOP (  ),
      .ENBWREN ( BRAM_EN_B ),
      .REGCEB ( net_gnd0 ),
      .RSTRAMB ( BRAM_Rst_B ),
      .RSTREGB ( net_gnd0 ),
      .WEBWE ( pgassign132 )
    );

endmodule

